#ifndef MATHUTILS_H
#define MATHUTILS_H

double *setv3(double* u, double s);
double *cpyv3(double* u, double* v);
double *scav3(double* u, double s, double* v);
double *addv3(double* u, double* v, double* w);
double *subv3(double* u, double* v, double* w);
double *cumv3(double* u, double* v,double a, double* w);
double *crossv3(double* a, double* b, double* c);
double longv3(double* a);
double lunitv3(double* a, double* b);
double *eyem3(double *a);
double *m3m3(double* a,double* b, double* c);
double *m3tm3(double* a, double* b, double* c);
double *m3v3(double* w, double* a, double* v);
double *tm3v3(double* w, double* a, double* v);
double *tm3m3( double* a,double* b, double* c);
double *mrotx(double *m, double a);
double *mrotz(double *m, double a);
double *mroty(double *m, double a);
double *av3tomrot(double* m, double a, double* v);
double *mrot2ltr (double *ltr, double *A);
double *porpor(double* a, double* b, double* c);
double *porpori(double* a, double* b, double* c);
double *setvec (double* u, double s, int n);
double *cpyvec (double* u, double* v, int n);
double *addvec (double* u, double* v, double* w, int n);
double *subvec (double* u, double* v, double* w, int n);
double dotvec (double* u, double* v, int n);
double *divvec (double* u, double* v, double* w, int n);
double *absvec (double* u, double* v, int n);
double xmaxvec (double* u, int n);
int imaxavec (double *u, int n);
double *scavec (double *u, double a, double *v, int n);
double *mattmat (double *a, double *b, double *c, int m, int n, int p);
double *tmatmat (double *a, double *b, double *c, int m, int n, int p);
int solvmat (double *X, double *A, double *Y, int n, int ns, int trp);
#endif
