#ifndef WIN32
#include <GL/gl.h>
#include <GL/glu.h>
#endif
#include <GL/glut.h>
#include <stdio.h>
#include <math.h>
#ifndef M_PI
#define M_PI	3.14159265358979323846
#endif 
#define DEG (180./M_PI)
#include "linutil.h"
#include "mllquad.h"
#include "robutils.h"

static int f2; /* numero de la fenetre aide */
static int width2 = 420; /*largeur fenetre aide */
static int height2 = 335; /*hauteur fenetre aide*/
static int AideCree = 0;

static int		Perspective = 1;    /* Flag utilisation perspectives  */

/* Point de vue */
static GLdouble	AngleVueVertical = 22.5,
				AziCam = 55.,
				AziCamBak = 0.,
				SitCam = 23.,
				SitCamBak = 0.,
				DistCam = 10.,

				AziSol = 90.,
				SitSol = 60.,
				DistSol = 15.,

				DeltaL = 0.025,
				DeltaA = 0.5 ;

static GLfloat PosiSol[4] = { 0., 0., 4., 1. };

static majsol(void) 
{
GLdouble p ;
   p = DistSol*cos(SitSol*M_PI/180.);
   PosiSol[2] = (GLfloat) (p*cos(AziSol*M_PI/180.));
   PosiSol[0] = (GLfloat) (p*sin(AziSol*M_PI/180.));
   PosiSol[1] = (GLfloat) (DistSol*sin(SitSol*M_PI/180.));
}

static double Ang[7] = {0., 60., -120., 0., 60., 0., 40.} ;
static int AngleSel = 0 ;

static void   ReadDataRobot(void);
static void   BuildRobot(void);
static void   APIENTRY glu_vertex(GLdouble *xyz);
static void   Keyboard(unsigned char key, int x, int y);
static void   SpecialKeys(int key, int x, int y);
static void   Redraw(void);
static void   Resize(int width, int height);
static void   AffichStr(int x, int y, char *string) ;
static void	  (*Idle_NULL)(void) = 0 ;


int				Width = 720;		/* Largeur fentre */
int				Height = 576;       /* Hauteur fentre */


/*----------------------------------------------------------------------------------*/
/* Callack dessin fenetre aide                                                      */
/*----------------------------------------------------------------------------------*/
static void Redraw2(void)
{
int ihaut;
char texte[256];
	glViewport(0,0,width2,height2);
	glClear(GL_COLOR_BUFFER_BIT);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(0.0, 1.*width2, 0.0, 1.*height2, -1.0, 1.0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
	glColor3d(0., 0.,0.);

	strcpy(texte, "Lorsque la fentre principale est active :"); ihaut = height2-15 ; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "ESC pour exit."); ihaut -= 15 ; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "Mouvements cartsiens : "); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    x, X : +/- Translation en x"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    y, Y : +/- Translation en y"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    z, Z : +/- Translation en z"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    l, L : +/- Rotation en lacet(z)"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    t, T : +/- Rotation en tangage(x)"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    r, R : +/- Rotation en roulis (y)"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "Mouvements articulaires : "); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    1,2..,7 : choix de l'axe"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    +, -    : rotation +/-"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "Mouvements observateur : "); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    e, E         : +/- eloignement"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "Points de vue"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    d, D  : dessus, dessous"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    f, F  : face, Dos"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    c, C  : cot droit, gauche"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    p, P  : perspective"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "ATTENTION : FIN VISU EN FERMANT CETTE FENETRE"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "   !!! FERMER A L'AIDE DU MENU CONTEXTUEL !!!"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	glFlush();
}

static void Resize2(int w, int h) 
{
    /* Memo les nouvelles valeurs */
    width2  = w;
    height2 = h;
}


/*****************************************************************************/
/*       Traitement du menu contextuel en fonction du clic                   */
/*****************************************************************************/
/* Valeur du clic */
#define MENU_AIDE		1

void TraiteMenu(int value)
{
	switch(value)
	{
	case MENU_AIDE :
		if (!AideCree)
		{
			glutInitDisplayMode(GLUT_RGBA);
			glutInitWindowSize(width2, height2);
			f2 =  glutCreateWindow("Aide Robot");
			glClearColor(0.85, 0.95, 0.95, 1.0);
			glutDisplayFunc(Redraw2);
			glutReshapeFunc(Resize2);
			AideCree = 1;
			glutChangeToMenuEntry(MENU_AIDE, "Fermer Aide", MENU_AIDE);
		}
		else 
		{
/*			glutSetWindow(f2);
			glutShowWindow();
			glutPopWindow(); */
			glutDestroyWindow(f2);
			glutChangeToMenuEntry(MENU_AIDE, "Aide Visu", MENU_AIDE);
			AideCree = 0;
		}
		break ;
	}
	glutPostRedisplay();
}



/*****************************************************************************/
/*                                 MAIN                                      */
/*****************************************************************************/

static GLuint	DisplayLists ;
static GLsizei  NbLists ;
static double abc ;
static double d01 ;
static double dqlim = 10 ; /* variation angulaire limite par pas */
static int okinv = 0 ;
static UnRobot Rob ;
static Por Dpm ;

int main(int  argc, char *argv[])
{
void LitDataRv80(UnRobot *rob);
int monMenu;

	LitDataRv80(&Rob) ;
	d01 = longv3(Rob.li[0]);
	abc = longv3(Rob.li[2]);

	Dpm[0]=Dpm[2]=0.; Dpm[1]=0.371; eyem3(Dpm+3);

    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
    glutInitWindowSize(Width, Height);
    glutCreateWindow("MLL_Visu RV80");

    glutDisplayFunc(Redraw);
    glutKeyboardFunc(Keyboard);
	glutSpecialFunc(SpecialKeys);
    glutReshapeFunc(Resize);

	monMenu = glutCreateMenu(TraiteMenu);
	glutAddMenuEntry("Aide Visu", MENU_AIDE);
	glutAttachMenu(GLUT_RIGHT_BUTTON);


    BuildRobot();
	majsol();

    glutMainLoop();

	glDeleteLists(DisplayLists,NbLists) ;

    return (0);
}


void LitDataRv80(UnRobot *rob)
{
int i, n, typ ;
double x,y,z,azi,sit,csit;
char DataRv80[6][16] = { {"1 0 0 1.5  0 90"},
						{"1 0 0 0    0  0"},
						{"1 0 1 0    0  0"},
						{"1 0 1 0   90  0"},
						{"1 0 0 0    0  0"},
						{"1 0 0 0   90  0"}};

	i = sizeof(double) ;
	n = sizeof(Vec3);

	rob->nq = 6 ;
	rob->ri = malloc(rob->nq*sizeof(int));;
	rob->ui = malloc(rob->nq*sizeof(Vec3));
	rob->li = malloc(rob->nq*sizeof(Vec3));
	for( n = 0 ; n < 6 ; n++)
	{
		sscanf(DataRv80[n],"%d %lf %lf %lf %lf %lf",&typ, &x, &y, &z, &azi, &sit);
		sit *= M_PI/180. ; azi *= M_PI/180.;
		rob->ri[n] = typ ;
		rob->li[n][0] = x ; 
		rob->li[n][1] = y ; 
		rob->li[n][2] = z ; 
		csit = cos(sit) ;
		rob->ui[n][0] = cos(azi)*csit ; 
		rob->ui[n][1] = sin(azi)*csit ; 
		rob->ui[n][2] = sin(sit) ; 
	}
}

/*****************************************************************************/

/* BuildRobot() - Construction du Robot */

/* 
	On considre que le repre robot  Zo vers le haut et Yo vers l'avant,
	en position initiale :
	Xo correspond  Zgl, 
	Yo correspond  Xgl,
	Zo correspond  Ygl,
	et rciproquement :
	Xgl correspond  Yo, 
	Ygl correspond  Zo,
	Zgl correspond  Xo.
	En consquence, une rotation robotique ZXY correspond aux 3 rotations
	successives Y0gl, Z1gl, X2gl.
	Pour Lacet = 0, l'axe robot est vers la droite
*/

/**********************************************************************************/
/*              Construction du robot                                             */
/**********************************************************************************/

static GLfloat noir[4] = {0.,0.,0.,1.} ;
static GLfloat gris001[4] = {0.01,0.01,0.01,1.} ;
static GLfloat gris010[4] = {0.1,0.1,0.1,1.} ;
static GLfloat gris020[4] = {0.2,0.2,0.2,1.} ;
static GLfloat gris030[4] = {0.3,0.3,0.3,1.} ;
static GLfloat gris040[4] = {0.4,0.4,0.4,1.} ;
static GLfloat gris050[4] = {0.5,0.5,0.5,1.} ;
static GLfloat gris060[4] = {0.6,0.6,0.6,1.} ;
static GLfloat gris070[4] = {0.7,0.7,0.7,1.} ;
static GLfloat gris080[4] = {0.8,0.8,0.8,1.} ;
static GLfloat gris090[4] = {0.9,0.9,0.9,1.} ;
static GLfloat blanc[4] = {1.,1.,1.,1.} ;
static GLfloat rouge[4] = {1.,0.,0.,1.} ;
static GLfloat vert[4] = {0.,1.,0.,1.} ;
static GLfloat bleu[4] = {0.,0.,1.,1.} ;
static GLfloat bleufluo[4] = {0.,1.,1.,1.} ;
static GLfloat jaune[4]={1.,1.,0.,1.};

static GLfloat col_c3[]={178./256.,62./256.,1./256.,1.};
static GLuint   DL_C0, DL_C1, DL_C2, DL_C3, DL_C4, DL_C5, DL_C6, DL_C7;			

static void BuildRobot(void)
{
#define nb_faces_cyl 24
#define nb_faces_bor 12

const double d_car_c0 = 1.5;				/* cot base carre */
const double h_car_c0 = 0.25*abc;			/* hauteur carr base */
const double r_cyl_c0 = 0.25*abc;			/* rayon cylindre base */
const double h_cyl_c1 = 0.10*abc;			/* Hauteur cylindre corps 1 */
const double r_cyl_c1 = (1.05*r_cyl_c0);	/* Rayon cylindre corps 1 */
const double e_sup_u2 = 0.05*abc;			/* Epaisseur support axe 2 */
const double dl_cha_u2 = (r_cyl_c0/sqrt(2.)-e_sup_u2);	/* demi-largeur chappe support axe 2 */
const double r_sup_u2 = (r_cyl_c0/sqrt(2.));	/* Rayon support axe 2 */
const double h_sup_u2 = (1.5*r_sup_u2);		/* hauteur support axe 2 */
const double h_cyl_c0 = (d01-h_car_c0-h_sup_u2-h_cyl_c1); /* hauteur cylindre base */
const double h_sup_u3 = (abc/2.);			/* hauteur support axe 3 */
const double h_car_c2 = (abc-h_sup_u3);		/* hauteur carr corps 2 */
const double l_car_c2 = (2.*dl_cha_u2-0.02*abc);/* largeur carr corps 2 */
const double e_sup_u3 = 0.04*abc;			/* Epaisseur support axe 3 */
const double dl_cha_u3 = (l_car_c2/2.-e_sup_u3);	/* demi-largeur chappe support axe 3 */
const double h_car_c3 = (0.7*abc);			/* hauteur carr corps 3 */
const double l_car_c3 = (2.*dl_cha_u3-0.02*abc);/* largeur carr corps 3 */
const double r_cyl1_c3 = r_sup_u2/cos(22.5*M_PI/180.) ; /* rayon cylindre 1 corps 3 */
const double e_cyl1_c3 = 0.1*abc;			/* epaisseur cylindre 1 corps 3 */
const double r_cyl2_c3 = (0.8*r_cyl1_c3);	/* rayon cylindre 2 corps 3 */
const double h_cyl_c4 = 0.04*abc;			/* hauteur cylindre corps 4 */
const double r_cyl_c4 = 0.06*abc;           /* rayon cylindre corps 4 */
const double r_sup_u5 = 0.04*abc;			/* rayon support axe 5 */
const double h_sup_u5 = 0.06*abc;		/* hauteur support axe 5 */
const double e_cyl2_c3 = 0.1*abc;			/* epaisseur cylindre 2 corps 3 */
const double e_cha_u5 = 0.04*abc;			/* Epaisseur chape axe 5 */
const double l_c5 = 2.*sqrt(r_cyl2_c3*r_cyl2_c3-r_sup_u5*r_sup_u5); /* largeur corps 5 */
const double dl_cha_u5 = l_c5/2.-e_cha_u5; /* demi largeur chape axe 5 */
const double l_sup_u5 = (2.*dl_cha_u5-0.02*abc);/*  largeur support axe 5 */
const double h_c5 = 2.*r_sup_u5 ;			/* hauteur corps 5 */
const double e_c5 = h_c5 ;					/* epaisseur corps 5 */
const double r_c6 = r_sup_u5 ;				/* rayon corps 6 */
const double h_c6 = h_c5 ;					/* hauteur corps 5 */
const double dx_pince=0.5*l_c5;
const double dy_pince=0.5*h_c5;
const double dz_pince=0.5*e_c5;
const double dy_doigt=dy_pince;
const double dx_doigt=dy_doigt;
const double dz_doigt= 0.75*dx_pince;

GLUquadricObj *quadric; /* Objet Quadric gnrique pour cylindres, cones, sphres etc... */
MLLquadricObj *quadmll; /* Objet mllQuadric gnrique pour boite, borne */

	glEnable(GL_CULL_FACE) ;  
	
	/* Cration objet quadric */

    quadric = gluNewQuadric();				/* Nouvel objet quadric gnrique */
    quadmll = mllNewQuadric();				/* Nouvel objet quadric gnrique */

	/* Numero des displays listes */
	NbLists = 8 ;
    DisplayLists = glGenLists(NbLists); 
	DL_C0 = DisplayLists; 
	DL_C1 = DL_C0+1 ; 
	DL_C2 = DL_C1+1 ; 
	DL_C3 = DL_C2+1 ;
	DL_C4 = DL_C3+1 ;
	DL_C5 = DL_C4+1 ;
	DL_C6 = DL_C5+1 ;
	DL_C7 = DL_C6+1 ;


	/* Construction du socle du Robot par une DisplayList */
	/* Z est vers le haut et X vers l'avant, l'origine est en bas */
	glNewList(DL_C0, GL_COMPILE);			/* Dfinition sans execution */
	{ /* crochet pour la lisibilit uniquement */
		glPushMatrix();
			glColor3fv(gris040);
			/* Base carre */
			mllBoite(quadmll, d_car_c0, d_car_c0, h_car_c0, -5);
			/* Cylindre au dessus de la base */
			glTranslated(0., 0., h_car_c0);
			glColor3fv(gris070);
			gluCylinder(quadric, r_cyl_c0, r_cyl_c0, h_cyl_c0, nb_faces_cyl, 2);
		glPopMatrix();
	} 
    glEndList();	/* DL_C0 */


	/* Construction du corps 1 du Robot par une DisplayList */
	/* Z est vers le haut et X vers l'avant, l'origine est sur l'axe */
	glNewList(DL_C1, GL_COMPILE);			/* Dfinition sans execution */
	{ /* crochet pour la lisibilit uniquement */
		glColor3fv(jaune);
		glPushMatrix();
		    /* on descend de la hauteur du support et du cylindre */
			glTranslated(0., 0., -(h_sup_u2+h_cyl_c1));
			gluCylinder(quadric, r_cyl_c1, r_cyl_c1, h_cyl_c1, nb_faces_cyl, 2); /* cylindre */
			glTranslated(0., 0., h_cyl_c1); /* on remonte  de sa hauteur */
			gluDisk(quadric, 0., r_cyl_c1, nb_faces_cyl, 1); /* on ferme sa partie suprieure */
			glTranslated(dl_cha_u2+e_sup_u2/2., 0., h_sup_u2); /* partie avant de la chappe */
			mllBorne(quadmll, e_sup_u2, r_sup_u2, h_sup_u2, nb_faces_bor, 0) ;
			glTranslated(-2*dl_cha_u2-e_sup_u2, 0., 0.); /* partie arrire de la chappe */
			mllBorne(quadmll, e_sup_u2, r_sup_u2, h_sup_u2, nb_faces_bor, 0) ;
		glPopMatrix();
	} 
    glEndList();	/* DL_C1 */

	/* Construction du corps 2 du Robot par une DisplayList */
	/* Z est vers le haut et X vers l'avant, l'origine est sur l'axe */
	glNewList(DL_C2, GL_COMPILE);			/* Dfinition sans execution */
	{ /* crochet pour la lisibilit uniquement */
		glColor3fv(jaune);
		glPushMatrix();		    
			glRotated(90., 1., 0., 0.); /* borne avec z selon -y robot */
			mllBorne(quadmll, l_car_c2, r_sup_u2, h_car_c2, nb_faces_bor, 1) ;
			glRotated(180., 1., 0., 0.); /* borne avec z selon y robot */
			glTranslated(dl_cha_u3+e_sup_u3/2., 0., h_car_c2+h_sup_u3); /* partie avant de la chappe */
			mllBorne(quadmll, e_sup_u3, r_sup_u2, h_sup_u3, nb_faces_bor, 0) ;
			glTranslated(-2*dl_cha_u3-e_sup_u3, 0., 0.); /* partie arrire de la chappe */
			mllBorne(quadmll, e_sup_u3, r_sup_u2, h_sup_u3, nb_faces_bor, 0) ;
		glPopMatrix();
	} 
    glEndList();	/* DL_C2 */

	/* Construction du corps 3 du Robot par une DisplayList */
	/* Z est vers le haut et X vers l'avant, l'origine est sur l'axe */
	glNewList(DL_C3, GL_COMPILE);			/* Dfinition sans execution */
	{ /* crochet pour la lisibilit uniquement */
		glColor3fv(jaune);
		glPushMatrix();		    
			glRotated(90., 1., 0., 0.); /* borne avec z selon -y robot */
			mllBorne(quadmll, l_car_c3, r_sup_u2, h_car_c3, nb_faces_bor, 0) ;
			glRotated(180., 1., 0., 0.); /* borne avec z selon y robot */
			glTranslated(0., 0., h_car_c3); /* on translate de la hauteur du carr corps c3 */
			glRotated(22.5, 0., 0., 1.); /* pour les facettes */
		    glColor3fv(col_c3);
			gluQuadricOrientation(quadric, GLU_INSIDE) ;
			gluDisk(quadric, 0., r_cyl1_c3, 8, 1); /* on ferme sa partie arrire */
			gluQuadricOrientation(quadric, GLU_OUTSIDE) ;			
			gluCylinder(quadric, r_cyl1_c3, r_cyl1_c3, e_cyl1_c3, 8, 2);
			glTranslated(0., 0., e_cyl1_c3); /* on translate de l'paisseur du cylindre1 corps 3 */
			gluDisk(quadric, 0., r_cyl1_c3, 8, 1); /* on ferme sa partie avant */
			gluCylinder(quadric, r_cyl2_c3, r_cyl2_c3, e_cyl2_c3, nb_faces_cyl, 2);
			glTranslated(0., 0., e_cyl2_c3); /* on translate de l'paisseur du cylindre1 corps 3 */
			gluDisk(quadric, 0., r_cyl2_c3, nb_faces_cyl, 1); /* on ferme sa partie avant */
		glPopMatrix();
	} 
    glEndList();	/* DL_C3 */

	/* Construction du corps 4 du Robot par une DisplayList */
	/* Z est vers le haut et X vers l'avant, l'origine est sur l'axe */
	glNewList(DL_C4, GL_COMPILE);			/* Dfinition sans execution */
	{ /* crochet pour la lisibilit uniquement */
		glColor3fv(gris040);
		glPushMatrix();		    
			glRotated(-90., 1., 0., 0.); /* borne avec z selon y robot */
			mllBorne(quadmll, l_sup_u5, r_sup_u5, h_sup_u5, nb_faces_bor, 1) ;
			glTranslated(0., 0., -h_sup_u5); /* on translate de la hauteur de la borne */
			gluDisk(quadric, 0., r_cyl_c4, 4, 1); /* on ferme la partie avant du cylindre */
			glTranslated(0., 0., -h_cyl_c4); /* on translate de la hauteur l'axe 5 */
			gluCylinder(quadric, r_cyl_c4, r_cyl_c4, h_cyl_c4, 4, 2);
		glPopMatrix();
	} 
    glEndList();	/* DL_C4 */

	/* Construction du corps 5 du Robot par une DisplayList */
	/* Z est vers le haut et X vers l'avant, l'origine est sur l'axe */
	glNewList(DL_C5, GL_COMPILE);			/* Dfinition sans execution */
	{ /* crochet pour la lisibilit uniquement */
		glColor3fv(jaune);
		glPushMatrix();		    
			glRotated(90., 1., 0., 0.); /* borne avec -z selon y robot */
			glTranslated(dl_cha_u5+e_cha_u5/2., 0., 0.);
			mllBorne(quadmll, e_cha_u5, r_sup_u5, h_sup_u5, nb_faces_bor, 0) ;
			glTranslated(-2*dl_cha_u5-e_cha_u5, 0., 0.);
			mllBorne(quadmll, e_cha_u5, r_sup_u5, h_sup_u5, nb_faces_bor, 0) ;
			glTranslated(dl_cha_u5+e_cha_u5/2., 0., -h_sup_u5-e_c5);
			mllBoite(quadmll, l_c5, h_c5, e_c5, 5) ;
		glPopMatrix();
	} 
    glEndList();	/* DL_C5 */
    
	/* Construction du corps 6 du Robot par une DisplayList */
	/* Z est vers le haut et X vers l'avant, l'origine est sur l'axe */
	glNewList(DL_C6, GL_COMPILE);			/* Dfinition sans execution */
	{ /* crochet pour la lisibilit uniquement */
		glPushMatrix();	
		    /* cylindre axe 6 */
			glColor3fv(gris040);
			glRotated(-90., 1., 0., 0.); /* z selon y robot */
			glTranslated(0., 0., h_sup_u5+e_c5);
			gluCylinder(quadric, r_c6, r_c6, h_c6, nb_faces_cyl, 2);
			glTranslated(0., 0., h_c6);
			gluDisk(quadric, 0., r_c6, nb_faces_cyl, 1); /* on ferme sa partie avant */
			/* paume de la pince */
			glColor3fv(gris070);
			mllBoite(quadmll, dx_pince, dy_pince, dz_pince, 6) ;
		glPopMatrix();
	} 
    glEndList();	/* DL_C6 */

	/* Construction de la pince du Robot par une DisplayList */
	/* Z est vers le haut et X vers l'avant, l'origine est sur l'axe */
	glNewList(DL_C7, GL_COMPILE);			/* Dfinition sans execution */
	{ /* crochet pour la lisibilit uniquement */
		glColor3fv(gris070);
		glPushMatrix();		    
			glRotated(-90., 1., 0., 0.); /* z selon y robot */
			glTranslated(0., 0., h_sup_u5+e_c5+h_c6+dz_pince);
			mllBoite(quadmll, dx_doigt, dy_doigt, dz_doigt, -5) ;
		glPopMatrix();
	} 
    glEndList();	/* DL_C7 */

	gluDeleteQuadric(quadric); 
	mllDeleteQuadric(quadmll); 
}


/* Keyboard() : Traitement touches */

static void Keyboard(unsigned char key, int x, int y)
{
    switch (key)
    {
	case 0x1b : /* Escape */
	    exit(0);
	    break;
	case '+' : 
		Ang[AngleSel] += DeltaA ;
		break ;

	case '-' : 
		Ang[AngleSel] -= DeltaA ;
		break ;

	case '1' :
	case '2' :
	case '3' :
	case '4' :
	case '5' :
	case '6' :
	case '7' :
		AngleSel = key - '1';
		break ;

	case 'd' : /* Vue de dessus */
	case 'D' : /* Vue de dessous */
		if (Perspective)
		{
			SitCamBak = SitCam ;
			AziCamBak = AziCam ;
			Perspective = 0;
		}
		AziCam = -90. ;
		if (key == 'd') SitCam = 90. ; else SitCam = -90.;
		break ;
	case 'e' : /* DistCam */
		DistCam += DeltaL ;
		break ;
	case 'E' : /* Cap */
		DistCam -= DeltaL ;
		break ;
	case 'f' : /* Vue de Face */
	case 'F' : /* Vue de Dos */
		if (Perspective)
		{
			SitCamBak = SitCam ;
			AziCamBak = AziCam ;
			Perspective = 0;
		}
		SitCam = 0. ;
		if (key == 'f') AziCam = 180. ; else AziCam = 0.;
		break ;
	case 'c' : /* Vue latrale */
	case 'C' : /* Vue latrale */
		if (Perspective)
		{
			SitCamBak = SitCam ;
			AziCamBak = AziCam ;
			Perspective = 0;
		}
		SitCam = 0. ;
		if (key == 'c') AziCam = -90. ; else AziCam = 90.;
		break ;
	case 'p' : /* Perspective */
	case 'P' : /* Perspective */
	    Perspective = 1 ;
		SitCam = SitCamBak ;
		AziCam = AziCamBak ;
	    break;
	case 'v':
		dqlim -= 0.5 ;
		if (dqlim < 0.5) dqlim = 0.5;
		break ;
	case 'V':
		dqlim += 0.5 ;
		break ;
	case 'l':
	case 'L':
	case 't':
	case 'T':
	case 'R':
	case 'r':
	case 'x':
	case 'X':
	case 'y':
	case 'Y':
	case 'Z':
	case 'z':
		{
		int N = Rob.nq ;
		char skey[2]="";
		double qi[6], Jacp[36], s;
		double cmax, dql[6], coefs[6], mat[9];
		Por Dop, Dom;

			s = 1.; if(isupper(key)) s = -s;

			setvec(dql, 0.2, N) ;
			scavec(qi,M_PI/180., Ang, N); /* Configuration courante */

			qi2DopetJp(&Rob, qi, Dop, Jacp); /* Situation courante */
			porpor(Dom,Dop,Dpm) ;

			/* Dcode la demande */
			switch (key)
			{
			case 'x' : Dom[0] += DeltaL; break;
			case 'X' : Dom[0] -= DeltaL; break;
			case 'y' : Dom[1] += DeltaL; break;
			case 'Y' : Dom[1] -= DeltaL; break;
			case 'z' : Dom[2] += DeltaL; break;
			case 'Z' : Dom[2] -= DeltaL; break;
			case 'l' : m3m3(Dom+3,Dom+3,mrotz(mat, DeltaA/DEG));break;
			case 'L' : m3m3(Dom+3,Dom+3,mrotz(mat,-DeltaA/DEG));break;
			case 't' : m3m3(Dom+3,Dom+3,mrotx(mat, DeltaA/DEG));break;
			case 'T' : m3m3(Dom+3,Dom+3,mrotx(mat,-DeltaA/DEG));break;
			case 'r' : m3m3(Dom+3,Dom+3,mroty(mat, DeltaA/DEG));break;
			case 'R' : m3m3(Dom+3,Dom+3,mroty(mat,-DeltaA/DEG));break;
			}

			/* Geoinv */
			porpori(Dop,Dom,Dpm);
			okinv = Dop2qi(&Rob, Dop, qi, 1000, 0.0005, 0.0005, 0.2, 0.2, dql);
			if (okinv < 0) break ;
			/* Conversion en degrs pour OPenGL */
			scavec(qi, 180./M_PI, qi, N);
			subvec(qi, qi, Ang, 6) ; /* Variation en degrs */
			setvec(dql, dqlim, N) ; /* variation maximale autorise */
			divvec(coefs,qi,dql,N); /* ratio au max */
			cmax = xmaxvec(absvec(coefs, coefs,N),N) ; /* max des ration */
			if (cmax > 1.) scavec(qi,1./cmax,qi,N); /* si >1 on sature */
			addvec (Ang, Ang, qi, N) ;
		}
		break;

	case 127 : /* Eloignement soleil */
		DistSol += 10.*DeltaL ;
		majsol() ;
		break ;
	}

    glutPostRedisplay();
}

// Pour faire tourner la scne avec les flches
static void SpecialKeys(int key, int x, int y)
{
	switch (key)
	{
	case GLUT_KEY_UP :
		SitCam += DeltaA ;
		if (SitCam > 180.) SitCam -= 360.;
		break ;
	case GLUT_KEY_DOWN :
		SitCam -= DeltaA ;
		if (SitCam < -180.) SitCam += 360.;
		break ;
	case GLUT_KEY_LEFT :
		AziCam += DeltaA ;
		if (AziCam > 180.) AziCam -= 360. ;
		break ;
	case GLUT_KEY_RIGHT :
		AziCam -= DeltaA ;
		if (AziCam < -180.) AziCam += 360. ;
		break ;

	case GLUT_KEY_PAGE_UP :
		SitSol += DeltaA ;
		if (SitSol > 180.) SitSol -= 360.;
		majsol() ;
		break ;
	case GLUT_KEY_PAGE_DOWN :
		SitSol -= DeltaA ;
		if (SitSol < -180.) SitSol += 360.;
		majsol() ;
		break ;
	case GLUT_KEY_HOME :
		AziSol += DeltaA ;
		if (AziSol > 180.) AziSol -= 360. ;
		majsol() ;
		break ;
	case GLUT_KEY_END :
		AziSol -= DeltaA ;
		if (AziSol < -180.) AziSol += 360. ;
		majsol() ;
		break ;
	case GLUT_KEY_INSERT : /* Rappochement soleil */
		DistSol -= 10.*DeltaL ;
		majsol() ;
		break ;
	}
	// Rafraichit la fentre
	glutPostRedisplay();
}



/* Redraw() : Redessine la fentre */
static double ltr[3]={0.,0.,0.};

static void Redraw(void)
{
int i;
double e;
char texte[256];
int N = Rob.nq ;
double qi[6], Jacp[36];
Por Dop, Dom;

    if (Height == 0) return ; 
    /* Reset du viewport */
    glViewport(0, 0, Width, Height);
    /* Raz  */
    glClearColor(0.85, 0.95, 0.95, 1.);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		
	glEnable(GL_DEPTH_TEST); /* Active lignes caches */


    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
	e = DistCam/5.;
	if(Perspective)
		gluPerspective(AngleVueVertical, 1.*Width/Height, 0.01, 2.*DistCam);
	else
		glOrtho(-e, e, -e, e, 0., 2.*DistCam);
 
	/*-------------------------
	   Dplacement de la camera
	  -------------------------*/
	/* Mouvements cameras opposs  ceux de la scene */
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
	glTranslated(0., 0., -DistCam); 
	glRotated(-SitCam, -1.0, 0.0, 0.0); /* -x pour positif de z vers y */
	glRotated(-AziCam, 0.0, 1.0, 0.0); 

    /*-------------------------------
	   Positionement des eclairages
	  -------------------------------*/
	/* La lumire */
    glEnable(GL_LIGHTING);  /* On active le calcul de l'clairage */ 
	/* Eclairage moyen gnral */
    glLightModelfv(GL_LIGHT_MODEL_AMBIENT, gris050); /* gris020 : dfaut */
	
	/* Il y a des faces internes visibles */
    /* glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE); */

    glEnable(GL_COLOR_MATERIAL); /* ncessaire */

    glEnable(GL_LIGHT0);
    glLightfv(GL_LIGHT0, GL_POSITION, PosiSol);
    glLightf(GL_LIGHT0, GL_SPOT_EXPONENT, 120.); 
    glLightfv(GL_LIGHT0, GL_AMBIENT, noir); /* blanc par dfaut */
    glLightfv(GL_LIGHT0, GL_DIFFUSE, gris050);  /* blanc par dfaut */
    glLightfv(GL_LIGHT0, GL_SPECULAR, noir);  /* blanc par dfaut */ 

	/*---------------------------
	   Transformation axes robot
	  ---------------------------*/
	glRotated(-90., 1., 0., 0.); /* On met z vertical */
	glRotated(-90., 0., 0., 1.); /* On met x vers l'avant */
	/*----------------------
		On dessine le Robot
	  ----------------------*/
	/* Base C0 */
	glTranslated(0., 0., -abc); /* on descend l'origine de 1 metre */
	glCallList(DL_C0);
	/* Corps C1 */
	glTranslated(0., 0., d01); /* Hauteur cors c1 */
	glRotated(Ang[0], 0.0, 0.0, 1.0); 
	glCallList(DL_C1);
	/* Corps C2 */
	glRotated(Ang[1], 1.0, 0.0, 0.0); 
	glCallList(DL_C2);
	/* Corps C3 */
	glTranslated(0., abc, 0.);
	glRotated(Ang[2], 1.0, 0.0, 0.0); 
	glCallList(DL_C3);
	/* Corps C4 */
	glTranslated(0., abc, 0.);
	glRotated(Ang[3], 0.0, 1.0, 0.0); 
	glCallList(DL_C4);
	/* Corps C5 */
	glRotated(Ang[4], 1.0, 0.0, 0.0); 
	glCallList(DL_C5); 
	/* Corps C6 */
	glRotated(Ang[5], 0.0, 1.0, 0.0); 
	glCallList(DL_C6); 
	/* Doigts de la pince */
	glTranslated(-fabs(Ang[6])/1000, 0., 0.);
	glCallList(DL_C7); 
	glTranslated(2*fabs(Ang[6])/1000, 0., 0.);
	glCallList(DL_C7); 

	/*---------------------------
	   Impression des positions 
	  ---------------------------*/
	glDisable(GL_DEPTH_TEST); /* Dsactive lignes caches */
    /*-------------------
	   On se met en 2D
	  -------------------*/
    glViewport(0, 0, Width, Height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(0.0, Width, 0.0, Height, -1.0, 1.0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
	/*--------------------
	   Plus d'clairage
	  --------------------*/
	glDisable(GL_LIGHTING);
	glColor3d(0., 0.,0.);
	/*--------------
	    On calcule la situation et on l'imprime
	  --------------*/
	scavec(qi,M_PI/180., Ang, N); /* Configuration courante */
	qi2DopetJp(&Rob, qi, Dop, Jacp); /* Situation courante */
	porpor(Dom,Dop,Dpm) ;
	mrot2ltr (ltr, Dom+3);


	i = sprintf(texte,"    X=%+4.2lf     Y=%+4.2lf     Z=%+4.2lf", Dom[0], Dom[1], Dom[2]);
	sprintf(texte+i,"   Cap=%+5.0lf   Ass=%+5.0lf   Rol=%+5.0lf  dQl=%4.2lf oki=%d", 
								ltr[0]*180/M_PI, ltr[1]*180/M_PI, ltr[2]*180/M_PI, dqlim, okinv);
	AffichStr (0, Height-15, texte) ;

	sprintf(texte," Axe1=%+5.0lf  Axe2=%+5.0lf  Axe2=%+5.0lf"
		           "  Axe4=%+5.0lf  Axe5=%+5.0lf  Axe6=%+5.0lf  Axe7=%+5.0lf"
			, Ang[0],Ang[1],Ang[2],Ang[3],Ang[4],Ang[5],Ang[6],Ang[7]/1000.);
	AffichStr (0, Height-30, texte) ;

	i = sprintf(texte,"  AziCam=%+4.0lf  SitCam=%+4.0lf  DistCam=%+4.0lf", AziCam, SitCam, DistCam);
	sprintf(texte+i,"  AziSol=%+4.0lf  SitSol=%+4.0lf  DistSol=%+4.0lf", AziSol, SitSol, DistSol);
	AffichStr (0, 15+3, texte) ;

	sprintf(texte," Clic droit pour menu contextuel (Aide)");
	AffichStr (0, 3, texte) ;	
    /* On swappe les buffers */
    glutSwapBuffers();

}


/* Resize() : Redimensionne la fentre */

static void Resize(int width, int height) 
{
    /* Memo les nouvelles valeurs */
    Width  = width;
    Height = height;
}

/* AffichStr */
static void AffichStr(int x, int y, char *string )
{
int len, i;

	glRasterPos2i(x, y);
	len = (int) strlen(string);
	for (i = 0; i < len; i++)
	{
		glutBitmapCharacter(GLUT_BITMAP_8_BY_13, string[i]);
	}
}
